﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using paravili.Steps;
using Sebarf.Diagnostics.Interfaces;

#endregion

namespace Tests.Basics {
	/// <summary>
	/// calculates the square root of a double value
	/// </summary>
	public class StepCalculateSquare : ProcessStepWithMeasurement<double> {
		protected override double OnProcess(double toProcess) {
			return toProcess * toProcess;
		}
	}

	/// <summary>
	/// converts the a byte value in its representing char value
	/// </summary>
	public class StepIntToChar : ProcessStepConverterWithMeasurement<byte, char> {
		protected override char Convert(byte toProcess) {
			return (char)toProcess;
		}
	}

	/// <summary>
	/// log something
	/// </summary>
	public class StepIndependent : ProcessStepWithMeasurement<object> {
		protected override object OnProcess(object toProcess) {
			Logger.WriteInformation("Hello world");
			return toProcess;
		}
	}
}