﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Collections.ObjectModel;
using System.Linq;
using paravili.Steps;
using Sebarf.Services.Interfaces;

#endregion

namespace paravili.Services {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class CaptureSourcesLocatorService : Service, ICaptureSourceLocatorService {
		#region Public Properties

		[ConfigurableValue]
		public ObservableCollection<ICaptureSource> CaptureSources { get; set; }

		#endregion

		#region Public Methods

		public CaptureSourcesLocatorService() {
			CaptureSources = new ObservableCollection<ICaptureSource>();
		}

		#endregion

		#region Private Methods

		// private methods located here

		#endregion

		#region Private Fields

		// private fields located here

		#endregion

		#region ICaptureSourceLocatorService Members

		public ICaptureSource[] GetAvailableSources() {
			return CaptureSources.ToArray();
		}

		#endregion
	}
}