﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using System.Drawing;
using Sebarf.Services.Interfaces;

#endregion

namespace paravili.Services {
	/// <summary>
	/// Description of the class
	/// </summary>
	public class CurrentImageInformationService : Service, ICurrentImageInformationProviderService,
												  ICurrentImageInformationLocatorService {
		#region Public Properties

		[ServiceRequest]
		public IResetHandlerService ResetHandlerService {
			set { value.Reset += OnReset; }
		}

		#endregion

		#region Private Methods

		private void OnReset(object sender, EventArgs e) {
			m_currentSize = default(Size);
		}

		#endregion

		#region Private Fields

		private Size m_currentSize;

		#endregion

		#region ICurrentImageInformationLocatorService Members

		public Size GetImageSize() {
			return m_currentSize;
		}

		#endregion

		#region ICurrentImageInformationProviderService Members

		public void SetImageSize(Size imageSize) {
			m_currentSize = imageSize;
		}

		#endregion
	}
}