﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using Emgu.CV;
using Emgu.CV.Structure;

#endregion

namespace paravili.Services {
	/// <summary>
	/// represents a query able data source for images 
	/// </summary>
	public interface ICaptureSource {
		#region Public Properties

		/// <summary>
		/// Gets the name of the datasource
		/// </summary>
		String Name { get; }

		/// <summary>
		/// returns if the data source is available
		/// </summary>
		bool IsAvailable { get; }

		#endregion

		#region Public Methods

		/// <summary>
		/// returns the next image
		/// </summary>
		/// <returns></returns>
		Image<Bgr, Byte> QueryImage();

		#endregion
	}
}