﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;

#endregion

namespace paravili.Services {
	/// <summary>
	/// is responsible for locating information about the currently used <see cref="ICaptureSource"/>
	/// </summary>
	public interface ICurrentCaptureSourceInformationLocatorService {
		#region Public Properties

		event EventHandler<CaptureSourceInformationEventArgs> CurrentCaputreSourceChanged;

		#endregion

		#region Public Methods

		ICaptureSource GetCurrentCaptureSource();

		#endregion
	}

	/// <summary>
	/// args of the event, produced by ICurrentCaptureSourceInformationLocatorService.CurrentCaputreSourceChanged
	/// </summary>
	public class CaptureSourceInformationEventArgs : EventArgs {
		public ICaptureSource OldCaptureSource { get; set; }
		public ICaptureSource NewCaptureSource { get; set; }
	}
}