﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System;
using paravili.Services;
using Sebarf.Services.Interfaces;

#endregion

namespace paravili.Steps {
	/// <summary>
	/// Increase the system time by using the ITimeService
	/// </summary>
	public class IncreaseApplicationTime : ProcessStepWithMeasurement<Object> {
		#region Public Properties

		[ServiceRequest]
		public ITimeService TimeService { get; set; }

		#endregion

		#region Public Methods

		protected override object OnProcess(object toProcess) {
			TimeService.IncreaseTime();
			return toProcess;
		}

		#endregion
	}
}