﻿#region Header

/*
Behavioral Rating of Dancing Human Crowds based on Motion Patterns
By

Pascal Hauser 
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

and

Raphael Gfeller
Dipl. Ing. in Informatik, Hochschule für Technik Rapperswil, 2006
Master Thesis, Hochschule für Technik Rapperswil, 2008-2010

*/

#endregion

#region Usings

using System.Drawing;
using Emgu.CV;
using Emgu.CV.Structure;
using paravili.Services;
using Sebarf.Services.Interfaces;

#endregion

namespace paravili.Steps {
	/// <summary>
	/// stores the information about the current images by using the ICurrentImage-InformationProviderService
	/// </summary>
	public class StoreImageInformationStep : ProcessStepWithMeasurement<Image<Lab, byte>> {
		#region Public Properties

		[ServiceRequest]
		public ICurrentImageInformationProviderService CurrentImageInformationProviderService { get; set; }

		#endregion

		#region Public Methods

		protected override Image<Lab, byte> OnProcess(Image<Lab, byte> toProcess) {
			if (toProcess != null) {
				CurrentImageInformationProviderService.SetImageSize(new Size(toProcess.Width, toProcess.Height));
			}
			return toProcess;
		}

		#endregion
	}
}