package lpl;

/**
 * Collection of constants necessary when using LPL API.
 * 
 * @author <a href="mailto:matthias.buchs@unifr.ch">Mathias Buchs</a>
 * @version 2.04.2007
 * @see NativeLPL
 */
public interface LPLConstants {
    // Attributes with LPL code (strings and numbers included) contents
    public static final int ATTR_PRE_TYPE = 1;
    public static final int ATTR_TYPE = 2;
    public static final int ATTR_GENUS = 3;
    public static final int ATTR_NAME = 4;
    public static final int ATTR_INDEX = 5;
    public static final int ATTR_EXPRESSION = 6;
    public static final int ATTR_CONDITION = 7;
    public static final int ATTR_RANGE_SUBJECT_TO = 8;
    public static final int ATTR_UNIT = 9;
    public static final int ATTR_IF = 10;
    public static final int ATTR_TO_FROM = 11;
    public static final int ATTR_ALIAS1 = 12;
    public static final int ATTR_ALIAS2 = 13;
    public static final int ATTR_QUOTE = 14;
    public static final int ATTR_COMMENT = 15;
    public static final int ATTR_DEFAULT = 16;
    public static final int ATTR_STRING = 17;
    public static final int ATTR_FREEZE = 18;
    public static final int ATTR_DELAY = 19;
    public static final int ATTR_QUALIFIED_NAME = 20;

    // Attributes with postfix tree notation values
    public static final int ATTR_POSTFIX_EXPR = 21;
    public static final int ATTR_POSTFIX_COND = 22;
    public static final int ATTR_POSTFIX_RANGE = 23;
    public static final int ATTR_POSTFIX_UNIT = 24;
    public static final int ATTR_POSTFIX_IF = 25;
    public static final int ATTR_POSTFIX_TO_FROM = 26;

    // Geni
    public static final int GENUS_ANY = 0;
    public static final int GENUS_SET = 1;
    public static final int GENUS_PARAMETER = 2;
    public static final int GENUS_VARIABLE = 3;
    public static final int GENUS_CONSTRAINT = 4;
    public static final int GENUS_UNIT = 5;
    public static final int GENUS_MODEL = 6;
    public static final int GENUS_MAX_MIN_QUERY = 7;
    public static final int GENUS_READ = 8;
    public static final int GENUS_WRITE = 9;
    public static final int GENUS_CHECK = 10;
    public static final int GENUS_OPTION = 11;
    public static final int GENUS_IF_ELSE = 12;
    public static final int GENUS_WHILE = 13;
    public static final int GENUS_FOR = 14;
    public static final int GENUS_INT_PROC_CALL = 15;
    public static final int GENUS_EXT_PROC_CALL = 16;
    public static final int GENUS_MODEL_CALL = 17;
    public static final int GENUS_ASSIGN = 18;
    public static final int GENUS_END = 19;
    public static final int GENUS_MODEL_END = 20;
    public static final int GENUS_ELSE = 21;

    // Dependency types
    public static final char DEPENDENCY_EXPR = 'e';
    public static final char DEPENDENCY_UNIT = 'u';
    public static final char DEPENDENCY_INDEX_COND = 'c';
    public static final char DEPENDENCY_RANGE = 'r';
    public static final char DEPENDENCY_PRIO_EXPR = 'p';
    public static final char DEPENDENCY_IF_COND = 'f';
    public static final char DEPENDENCY_INDEX = 'i';
    public static final char DEPENDENCY_INDEX_OP = 'j';
    public static final char DEPENDENCY_PASSIVE_INDEX = 'k';
    public static final char DEPENDENCY_UNDEFINDED = ' ';

    // Entity values
    public static final int VALUE_NUMERIC = 20;
    public static final int VALUE_RHS = 21;
    public static final int VALUE_LHS = 22;
    public static final int VALUE_LRHS = 23;
    public static final int VALUE_LOWER = 24;
    public static final int VALUE_UPPER = 25;
    public static final int VALUE_DUAL = 26;
    public static final int VALUE_LOWER_SENS_RANGE = 27;
    public static final int VALUE_UPPER_SENS_RANGE = 28;
    public static final int VALUE_STRING = 30;
    public static final int VALUE_ELEMENT_NAME = 31;
    public static final int VALUE_ELEMENT_STRING_NAME = 32;

    // Global values
    public static final int VALUE_SOLUTION_STATUS = 35;
    public static final int VALUE_PROBLEM_TYPE = 36;
    public static final int VALUE_ELAPSED_TIME = 37;
    public static final int VALUE_MIP_LOWER_BOUND = 38;
    public static final int VALUE_MIP_UPPER_BOUND = 39;
    public static final int VALUE_SOLVER_ERROR = 40;

    // Kernel information
    public static final int MODEL_NAME = 1;
    public static final int COMPILER_SWITCHES = 2;
    public static final int MAXA = 3;
    public static final int MAXT = 4;
    public static final int MAXR = 5;
    public static final int FILE_SEARCH_PATH = 6;
    public static final int CURRENT_DIR = 7;
    public static final int LPL_VERSION = 8;
    public static final int APP_DIR = 9;
    public static final int PROBLEM_TYPE = 10;
    public static final int SOLUTION_STATUS = 11;
    public static final int ASSIGNED_PARAMETER_LIST = 12;
    public static final int LOG_MESSAGE = 13;
    public static final int SOLVER_ERROR = 14;
    public static final int CLIENT_ID = 15;
    public static final int LPL_VERSION_TYPE = 16;
    public static final int DB_SNAPSHOT_GENERATION = 17;
}
